Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util.filter
Class LessFilter

`java.lang.Object
com.tangosol.util.Base
com.tangosol.util.BitHelper
com.tangosol.util.ExternalizableHelper
com.tangosol.util.filter.ExtractorFilter
com.tangosol.util.filter.ComparisonFilter
com.tangosol.util.filter.LessFilter`

All Implemented Interfaces:
  ExternalizableLite, PortableObject, Filter, EntryFilter, IndexAwareFilter, Serializable

      public class LessFilter

extends ComparisonFilter
implements IndexAwareFilter

Filter which compares the result of a method invocation with a value for "Less" condition. In a case when either result of a method invocation or a value to compare are equal to null, the `evaluate` test yields `false`. This approach is equivalent to the way the NULL values are handled by SQL.

Author:
  cp/gg 2002.10.29

Field Summary

Fields inherited from class com.tangosol.util.filter.ComparisonFilter
`m_oValue`

Fields inherited from class com.tangosol.util.filter.ExtractorFilter
`EVAL_COST, m_extractor`

Constructor Summary
`LessFilter()` Default constructor (necessary for the ExternalizableLite interface).
`LessFilter(String sMethod, Comparable oValue)` Construct a LessFilter for testing "Less" condition.
`LessFilter(String sMethod, double dValue)` Construct a LessFilter for testing "Less" condition.
`LessFilter(String sMethod, float fValue)` Construct a LessFilter for testing "Less" condition.
`LessFilter(String sMethod, int iValue)` Construct a LessFilter for testing "Less" condition.
`LessFilter(String sMethod, long lValue)` Construct a LessFilter for testing "Less" condition.
`LessFilter(ValueExtractor extractor, Comparable oValue)` Construct a LessFilter for testing "Less" condition.

Method Summary
`Filter` | `applyIndex(Map mapIndexes, Set setKeys)` Filter remaining keys using a Map of available indexes.
`int` | `calculateEffectiveness(Map mapIndexes, Set setKeys)` Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be.
`protected boolean` | `evaluateExtracted(Object oExtracted)` Evaluate the specified extracted value.

Methods inherited from class com.tangosol.util.filter.ComparisonFilter
`calculateIteratorEffectiveness, calculateMatchEffectiveness, calculateRangeEffectiveness, equals, getValue, hashCode, readExternal, readExternal, toString, writeExternal, writeExternal`

Methods inherited from class com.tangosol.util.filter.ExtractorFilter
`evaluate, evaluateEntry, extract, getValueExtractor`

Methods inherited from class com.tangosol.util.BitHelper
`countBits, countBits, countBits, indexOfLSB, indexOfLSB, indexOfLSB, indexOfMSB, indexOfMSB, indexOfMSB, rotateLeft, rotateLeft, rotateLeft, rotateRight, rotateRight, rotateRight, toBitString, toBitString, toBitString`

Methods inherited from interface com.tangosol.util.filter.EntryFilter
`evaluateEntry`

Methods inherited from interface com.tangosol.util.Filter
`evaluate`

Constructor Detail

### LessFilter

    public LessFilter()

  Default constructor (necessary for the ExternalizableLite interface).

### LessFilter

    public LessFilter(ValueExtractor extractor,
                      Comparable oValue)

  Construct a LessFilter for testing "Less" condition.
  Parameters:
    `extractor` - the ValueExtractor to use by this filter
    `oValue` - the object to compare the result with

### LessFilter

    public LessFilter(String sMethod,
                      Comparable oValue)

  Construct a LessFilter for testing "Less" condition.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `oValue` - the object to compare the result with

### LessFilter

    public LessFilter(String sMethod,
                      int iValue)

  Construct a LessFilter for testing "Less" condition.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `iValue` - the integer value to compare the result with

### LessFilter

    public LessFilter(String sMethod,
                      long lValue)

  Construct a LessFilter for testing "Less" condition.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `lValue` - the long value to compare the result with

### LessFilter

    public LessFilter(String sMethod,
                      float fValue)

  Construct a LessFilter for testing "Less" condition.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `fValue` - the float value to compare the result with

### LessFilter

    public LessFilter(String sMethod,
                      double dValue)

  Construct a LessFilter for testing "Less" condition.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `dValue` - the double value to compare the result with

Method Detail

### evaluateExtracted

    protected boolean evaluateExtracted(Object oExtracted)

  Evaluate the specified extracted value.
  Specified by:
    `evaluateExtracted` in class `ExtractorFilter`
  Parameters:
    `oExtracted` - an extracted value to evaluate

### calculateEffectiveness

    public int calculateEffectiveness(Map mapIndexes,
                                      Set setKeys)

  Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be. <p/> The returned value is an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys. An operation that requires no more than a single access to the index content (i.e. Equals, NotEquals) has an effectiveness of one. Evaluation of a single entry is assumed to have an effectiveness that depends on the index implementation and is usually measured as a constant number of the single operations. This number is referred to as evaluation cost. <p/> If the effectiveness of a filter evaluates to a number larger than the `keySet.size() * <evaluation cost>` then a user could avoid using the index and iterate through the keySet calling `evaluate` rather then `applyIndex`.
  Specified by:
    `calculateEffectiveness` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the set of keys that will be filtered; read-only
  Returns:
    an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys

### applyIndex

    public Filter applyIndex(Map mapIndexes,
                             Set setKeys)

  Filter remaining keys using a Map of available indexes. <p/> The filter is responsible for removing all keys from the passed set of keys that the applicable indexes can prove should be filtered. If the filter does not fully evaluate the remaining keys using just the index information, it must return a filter (which may be an `EntryFilter`) that can complete the task using an iterating implementation. If, on the other hand, the filter does fully evaluate the remaining keys using just the index information, then it should return null to indicate that no further filtering is necessary.
  Specified by:
    `applyIndex` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the mutable set of keys that remain to be filtered
  Returns:
    a `Filter` object (which may be an `EntryFilter`) that can be used to process the remaining keys, or null if no additional filter processing is necessary

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.